/*  includes y variables necesarias.  */

#include <sys/types.h>
#include <sys/socket.h>
#include <stdio.h>
#include <sys/un.h>
#include <unistd.h>
#include <stdlib.h>

int main()
{
    int sockfd;
    int len;
    struct sockaddr_un address;
    int result;
    char ch = 'A', ch2;

/*  crear un socket.  */
    sockfd = socket(AF_UNIX, SOCK_STREAM, 0);

/*  Nombrar el socket.  */
    address.sun_family = AF_UNIX;
    strcpy(address.sun_path, "server_socket");
    len = sizeof(address);

/*  conectar el socket con el socket del servidor.  */
    result = connect(sockfd, (struct sockaddr *)&address, len);

    if(result == -1) {
        perror("client1: error!!");
        exit(1);
    }

/*  Ahora podemos escribir/leer usando la variable sockfd.  */
    write(sockfd, &ch, 1);		//envia char A
    read(sockfd, &ch2, 1);		//recibe char del servidor
    printf("char enviado=%c char recibido=%c\n", ch, ch2);
    close(sockfd);
    exit(0);
}
